'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _objectPathImmutable = require('object-path-immutable');

var _objectPathImmutable2 = _interopRequireDefault(_objectPathImmutable);

var _utilities = require('../utilities');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var formIndex = 0;

var _default = function _default(WrappedComponent) {
  var _class, _temp;

  if (!WrappedComponent.prototype.isReactComponent) {
    throw 'Cannot extend a pure component';
  }

  return _temp = _class = function (_WrappedComponent) {
    _inherits(_class, _WrappedComponent);

    function _class(props, context) {
      _classCallCheck(this, _class);

      var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, props, context));

      _this.getValue = function () {
        return _this.__getValue__REACT_HOT_LOADER__.apply(_this, arguments);
      };

      _this.onChange = function () {
        return _this.__onChange__REACT_HOT_LOADER__.apply(_this, arguments);
      };

      _this.formIndex = formIndex;
      formIndex += 1;
      _this.state = _extends({}, _this.state || {}, {
        values: _this.getDefaults()
      });

      _this.subscriptions = [];
      return _this;
    }

    _createClass(_class, [{
      key: '__onChange__REACT_HOT_LOADER__',
      value: function __onChange__REACT_HOT_LOADER__() {
        return this.__onChange__REACT_HOT_LOADER__.apply(this, arguments);
      }
    }, {
      key: '__getValue__REACT_HOT_LOADER__',
      value: function __getValue__REACT_HOT_LOADER__() {
        return this.__getValue__REACT_HOT_LOADER__.apply(this, arguments);
      }
    }, {
      key: 'getChildContext',
      value: function getChildContext() {
        var _this2 = this;

        var superChildContext = typeof _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'getChildContext', this) === 'function' ? _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'getChildContext', this).call(this) : {};
        return _extends({}, superChildContext, {
          nfGetValue: this.getValue,
          nfOnChange: this.onChange,
          nfFullName: function nfFullName() {
            return [];
          },
          nfFormIndex: this.formIndex,
          formSubscription: {
            subscribe: function subscribe(callback) {
              return _this2.subscriptions.push(callback);
            },
            unsubscribe: function unsubscribe(callback) {
              _this2.subscriptions = _this2.subscriptions.filter(function (v) {
                return v !== callback;
              });
            }
          }
        });
      }
    }, {
      key: 'getDefaults',
      value: function getDefaults() {
        if (typeof _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'getDefaults', this) !== 'function') {
          return {};
        }
        return _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'getDefaults', this).call(this);
      }
    }, {
      key: '__getValue__REACT_HOT_LOADER__',
      value: function __getValue__REACT_HOT_LOADER__() {
        return this.state.values;
      }
    }, {
      key: '__onChange__REACT_HOT_LOADER__',
      value: function __onChange__REACT_HOT_LOADER__(e) {
        var _this3 = this;

        this.setState({
          values: _objectPathImmutable2.default.set(this.state.values, e.target.name, e.target.value)
        }, function () {
          return _this3.triggerUpdate();
        });
      }
    }, {
      key: 'triggerUpdate',
      value: function triggerUpdate() {
        this.subscriptions.forEach(function (callback) {
          return callback();
        });
      }

      // eslint-disable-next-line class-methods-use-this

    }, {
      key: 'formProps',
      value: function formProps() {
        return {};
      }
    }, {
      key: 'render',
      value: function render() {
        var content = _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', this) ? _get(_class.prototype.__proto__ || Object.getPrototypeOf(_class.prototype), 'render', this).call(this) : this.props.children;
        return _react2.default.createElement(
          'form',
          this.formProps(),
          content
        );
      }
    }]);

    return _class;
  }(WrappedComponent), _class.displayName = 'handler(' + (0, _utilities.getDisplayName)(WrappedComponent) + ')', _class.childContextTypes = {
    nfGetValue: _propTypes2.default.func.isRequired,
    nfOnChange: _propTypes2.default.func.isRequired,
    nfFullName: _propTypes2.default.func.isRequired,
    nfFormIndex: _propTypes2.default.number.isRequired,
    formSubscription: _propTypes2.default.objectOf(_propTypes2.default.func).isRequired
  }, _temp;
};

exports.default = _default;
;

var _temp2 = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(formIndex, 'formIndex', 'src/HOC/handler.jsx');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/HOC/handler.jsx');
}();

;