'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utilities = require('../utilities');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Input = function (_React$PureComponent) {
  _inherits(Input, _React$PureComponent);

  function Input() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Input);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Input.__proto__ || Object.getPrototypeOf(Input)).call.apply(_ref, [this].concat(args))), _this), _this.onCheckboxChange = function () {
      var _this2;

      return (_this2 = _this).__onCheckboxChange__REACT_HOT_LOADER__.apply(_this2, arguments);
    }, _this.onRadioChange = function () {
      var _this3;

      return (_this3 = _this).__onRadioChange__REACT_HOT_LOADER__.apply(_this3, arguments);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Input, [{
    key: '__onRadioChange__REACT_HOT_LOADER__',
    value: function __onRadioChange__REACT_HOT_LOADER__() {
      return this.__onRadioChange__REACT_HOT_LOADER__.apply(this, arguments);
    }
  }, {
    key: '__onCheckboxChange__REACT_HOT_LOADER__',
    value: function __onCheckboxChange__REACT_HOT_LOADER__() {
      return this.__onCheckboxChange__REACT_HOT_LOADER__.apply(this, arguments);
    }
  }, {
    key: '__onCheckboxChange__REACT_HOT_LOADER__',

    // Ignore the name for radios, since we need them for radio groups
    value: function __onCheckboxChange__REACT_HOT_LOADER__(e) {
      return this.props.onChange((0, _utilities.fakeChangeEvent)(e.target.name, e.target.checked));
    }
  }, {
    key: '__onRadioChange__REACT_HOT_LOADER__',
    value: function __onRadioChange__REACT_HOT_LOADER__(e) {
      return this.props.onChange(e.target.value);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          value = _props.value,
          props = _objectWithoutProperties(_props, ['value']);

      var valueProp = { value: value };
      if (props.type === 'checkbox') {
        valueProp = { checked: value, onChange: this.onCheckboxChange };
      } else if (props.type === 'radio') {
        valueProp = {
          checked: value === this.props['data-value'],
          value: value,
          onChange: this.onRadioChange,
          name: this.props['data-name']
        };
      }
      return _react2.default.createElement('input', _extends({}, props, valueProp));
    }
  }]);

  return Input;
}(_react2.default.PureComponent);

Input.propTypes = {
  type: _propTypes2.default.string,
  value: _propTypes2.default.any.isRequired, // eslint-disable-line react/forbid-prop-types
  onChange: _propTypes2.default.func.isRequired,
  'data-value': _propTypes2.default.any, // eslint-disable-line react/forbid-prop-types
  'data-name': _propTypes2.default.string.isRequired
};
Input.defaultProps = {
  type: '',
  'data-value': undefined
};
var _default = Input;
exports.default = _default;
;

var _temp2 = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(Input, 'Input', 'src/components/Input.jsx');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/components/Input.jsx');
}();

;