'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Subscription = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utilities = require('../utilities');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Subscription = exports.Subscription = function () {
  function Subscription(subscriber, onChange) {
    _classCallCheck(this, Subscription);

    this.subscriber = subscriber;
    this.updateSubscriber = onChange;
  }

  _createClass(Subscription, [{
    key: 'trySubscribe',
    value: function trySubscribe() /* props */{
      if (!this.subscriber.context || !this.subscriber.context.formSubscription) {
        return;
      }

      this.tryUnsubscribe();
      this.subscriber.context.formSubscription.subscribe(this.updateSubscriber);
    }
  }, {
    key: 'tryUnsubscribe',
    value: function tryUnsubscribe() {
      if (!this.subscriber.context || !this.subscriber.context.formSubscription) {
        return;
      }
      this.subscriber.context.formSubscription.unsubscribe(this.updateSubscriber);
    }
  }]);

  return Subscription;
}();

var Subscriber = function (_React$Component) {
  _inherits(Subscriber, _React$Component);

  function Subscriber(props, context) {
    _classCallCheck(this, Subscriber);

    var _this = _possibleConstructorReturn(this, (Subscriber.__proto__ || Object.getPrototypeOf(Subscriber)).call(this, props, context));

    _this.state = {};
    _this.subscription = new Subscription(_this, function () {
      return _this.triggerUpdate();
    });
    return _this;
  }

  _createClass(Subscriber, [{
    key: 'triggerUpdate',
    value: function triggerUpdate() {
      this.setState({});
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.subscription.trySubscribe(this.props);
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      return (0, _utilities.shallowCompare)(nextProps, this.props) || (0, _utilities.shallowCompare)(nextState, this.state);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.subscription.tryUnsubscribe();
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        _react2.default.Fragment,
        null,
        this.props.children
      );
    }
  }]);

  return Subscriber;
}(_react2.default.Component);

Subscriber.propTypes = {
  children: _propTypes2.default.node
};
Subscriber.defaultProps = {
  children: null
};
Subscriber.contextTypes = {
  formSubscription: _propTypes2.default.objectOf(_propTypes2.default.func).isRequired
};
var _default = Subscriber;
exports.default = _default;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(Subscription, 'Subscription', 'src/components/Subscriber.jsx');

  __REACT_HOT_LOADER__.register(Subscriber, 'Subscriber', 'src/components/Subscriber.jsx');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/components/Subscriber.jsx');
}();

;