'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _ValueSubscriber2 = require('./ValueSubscriber');

var _ValueSubscriber3 = _interopRequireDefault(_ValueSubscriber2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var runValidationRules = function runValidationRules(rules, value, invalidate) {
  if ((typeof rules === 'undefined' ? 'undefined' : _typeof(rules)) === 'object') {
    if (Array.isArray(rules)) {
      rules.forEach(function (rule) {
        return runValidationRules(rule, value, invalidate);
      });
    } else {
      Object.entries(rules).forEach(function (_ref) {
        var _ref2 = _slicedToArray(_ref, 2),
            key = _ref2[0],
            rule = _ref2[1];

        runValidationRules(rule, value[key], function (error) {
          var nestedName = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
          return invalidate(error, [key].concat(nestedName));
        });
      });
    }
  } else {
    rules(value, invalidate);
  }
};

var Validation = function (_ValueSubscriber) {
  _inherits(Validation, _ValueSubscriber);

  function Validation(props, context) {
    _classCallCheck(this, Validation);

    var _this = _possibleConstructorReturn(this, (Validation.__proto__ || Object.getPrototypeOf(Validation)).call(this, props, context));

    _this.state = _extends({}, _this.state, {
      validationResult: []
    });
    return _this;
  }

  _createClass(Validation, [{
    key: 'triggerUpdate',
    value: function triggerUpdate() {
      _get(Validation.prototype.__proto__ || Object.getPrototypeOf(Validation.prototype), 'triggerUpdate', this).call(this);
      this.runValidation();
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      _get(Validation.prototype.__proto__ || Object.getPrototypeOf(Validation.prototype), 'componentDidMount', this).call(this);
      this.runValidation();
    }

    // TODO: If the rules prop changes, revalidate

  }, {
    key: 'runValidation',
    value: function runValidation() {
      var value = this.getValue();
      var result = [];
      var invalidate = function invalidate(error) {
        var nestedName = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

        result.push([nestedName, error]);
      };
      runValidationRules(this.props.rules, value, invalidate);

      // Check validation results for differences
      if (this.state.validationResult.length === result.length) {
        var validationChanged = false;
        var i = 0;
        while (validationChanged === false && i < result.length) {
          var newVal = result[i];
          var oldVal = this.state.validationResult[i];
          if (newVal[0].join('|') !== oldVal[0].join('|') || newVal[1] !== oldVal[1]) {
            validationChanged = true;
          }
          i += 1;
        }

        if (validationChanged === false) {
          return;
        }
      }

      var oldResult = this.state.validationResult;
      this.setState({ validationResult: result });
      this.context.nfUpdateValidation(oldResult, result);
    }
  }, {
    key: 'renderErrors',
    value: function renderErrors() {
      if (this.state.validationResult.length === 0) {
        return null;
      }
      return _react2.default.createElement(
        'ul',
        null,
        this.state.validationResult.map(function (v, i) {
          return _react2.default.createElement(
            'li',
            { key: i },
            v
          );
        })
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var displayBeforeChildren = this.props.displayBeforeChildren;

      var children = _get(Validation.prototype.__proto__ || Object.getPrototypeOf(Validation.prototype), 'render', this).call(this);
      return _react2.default.createElement(
        _react2.default.Fragment,
        null,
        displayBeforeChildren ? null : children,
        this.renderErrors(),
        displayBeforeChildren ? children : null
      );
    }
  }]);

  return Validation;
}(_ValueSubscriber3.default);

Validation.propTypes = _extends({}, _ValueSubscriber3.default.propTypes, {
  rules: _propTypes2.default.oneOfType([_propTypes2.default.func, _propTypes2.default.arrayOf(_propTypes2.default.func), _propTypes2.default.objectOf([_propTypes2.default.func, _propTypes2.default.arrayOf(_propTypes2.default.func)])]).isRequired,
  displayBeforeChildren: _propTypes2.default.bool
});
Validation.defaultProps = _extends({}, _ValueSubscriber3.default.defaultProps, {
  displayBeforeChildren: false
});
Validation.contextTypes = _extends({}, _ValueSubscriber3.default.contextTypes, {
  nfUpdateValidation: _propTypes2.default.func.isRequired
});
var _default = Validation;
exports.default = _default;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(runValidationRules, 'runValidationRules', 'src/components/Validation.jsx');

  __REACT_HOT_LOADER__.register(Validation, 'Validation', 'src/components/Validation.jsx');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/components/Validation.jsx');
}();

;