'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utilities = require('../utilities');

var _Subscriber2 = require('./Subscriber');

var _Subscriber3 = _interopRequireDefault(_Subscriber2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ValueSubscriber = function (_Subscriber) {
  _inherits(ValueSubscriber, _Subscriber);

  function ValueSubscriber(props, context) {
    _classCallCheck(this, ValueSubscriber);

    var _this = _possibleConstructorReturn(this, (ValueSubscriber.__proto__ || Object.getPrototypeOf(ValueSubscriber)).call(this, props, context));

    _this.getName = function () {
      return _this.__getName__REACT_HOT_LOADER__.apply(_this, arguments);
    };

    _this.oldValue = undefined;
    return _this;
  }

  _createClass(ValueSubscriber, [{
    key: '__getName__REACT_HOT_LOADER__',
    value: function __getName__REACT_HOT_LOADER__() {
      return this.__getName__REACT_HOT_LOADER__.apply(this, arguments);
    }
  }, {
    key: 'getChildContext',
    value: function getChildContext() {
      var _this2 = this;

      return {
        nfGetValue: function nfGetValue() {
          return _this2.getValue();
        },
        nfFullName: this.getName
      };
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      _get(ValueSubscriber.prototype.__proto__ || Object.getPrototypeOf(ValueSubscriber.prototype), 'componentDidMount', this).call(this);
      this.oldValue = this.getValue();
    }
  }, {
    key: 'onChange',
    value: function onChange(e) {
      var name = this.getName();
      var value = e;
      if (e && e.target) {
        if (typeof e.target.name !== 'undefined' && e.target.name !== '') {
          name = name.concat(e.target.name);
        }
        value = e.target.value; // eslint-disable-line prefer-destructuring
      }
      this.context.nfOnChange((0, _utilities.fakeChangeEvent)(name, value));
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState, nextContext) {
      if (_get(ValueSubscriber.prototype.__proto__ || Object.getPrototypeOf(ValueSubscriber.prototype), 'shouldComponentUpdate', this).call(this, nextProps, nextState, nextContext)) {
        return true;
      }

      var newValue = this.getValue();
      if (newValue !== this.oldValue) {
        this.oldValue = newValue;
        return true;
      }

      return false;
    }
  }, {
    key: 'getValue',
    value: function getValue() {
      var value = this.context.nfGetValue();
      if (!value) {
        return value;
      }
      return typeof this.props.name !== 'undefined' && this.props.name !== '' ? value[this.props.name] : value;
    }
  }, {
    key: '__getName__REACT_HOT_LOADER__',
    value: function __getName__REACT_HOT_LOADER__() {
      var parentName = this.context.nfFullName();
      if (typeof this.props.name === 'undefined' || this.props.name === '') {
        return parentName;
      }
      return parentName.concat(this.props.name);
    }
  }]);

  return ValueSubscriber;
}(_Subscriber3.default);

ValueSubscriber.propTypes = _extends({}, _Subscriber3.default.propTypes, {
  name: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number])
});
ValueSubscriber.defaultProps = _extends({}, _Subscriber3.default.defaultProps, {
  name: ''
});
ValueSubscriber.contextTypes = _extends({}, _Subscriber3.default.contextTypes, {
  nfGetValue: _propTypes2.default.func.isRequired,
  nfOnChange: _propTypes2.default.func.isRequired,
  nfFullName: _propTypes2.default.func.isRequired
});
ValueSubscriber.childContextTypes = {
  nfGetValue: _propTypes2.default.func.isRequired,
  nfFullName: _propTypes2.default.func.isRequired
};
var _default = ValueSubscriber;
exports.default = _default;
;

var _temp = function () {
  if (typeof __REACT_HOT_LOADER__ === 'undefined') {
    return;
  }

  __REACT_HOT_LOADER__.register(ValueSubscriber, 'ValueSubscriber', 'src/components/ValueSubscriber.jsx');

  __REACT_HOT_LOADER__.register(_default, 'default', 'src/components/ValueSubscriber.jsx');
}();

;